# -*- coding: utf-8 -*-
from setuphelpers import *

appx_names = ['Microsoft.Copilot','Microsoft.MicrosoftOfficeHub']

def install() :

    installed_appx_packages = run_powershell("Get-AppxPackage -AllUsers")

    for app in installed_appx_packages :
        if app['Name'] in appx_names :
            #the following key prevents appx from being reinstalled during OS upgrades
            registry_set(HKEY_LOCAL_MACHINE,fr'SOFTWARE\Microsoft\Windows\CurrentVersion\Appx\AppxAllUserStore\Deprovisioned\{app["PackageFamilyName"]}','','')
            try :
                print("Removing : %s" % app['Name'])
                run_powershell("Remove-AppxPackage -AllUsers -Package %s" % app['PackageFullName'])
            except :
                print("Unable to remove : %s" % app['Name'])
    print("Done")

# To remove appx installed on current user
def session_setup():

    print("Removing: Unwanted Microsoft Store applications...")
    installed_appx_packages = run_powershell("Get-AppxPackage")

    for app in installed_appx_packages :
        if app['Name'] in appx_names :
            try :
               print("Removing : %s" % app['Name'])
               run_powershell("Remove-AppxPackage -Package %s" % app['PackageFullName'])
            except :
                print("Unable to remove : %s" % app['Name'])

def audit():
    audit_status = "OK"
    installed_appx_packages = run_powershell("Get-AppxPackage -AllUsers")

    for app in installed_appx_packages :
        if app['Name'] in appx_names :
            print("WARNING : %s is installed" % app['Name'])
            print("Force install to remove the application")
            audit_status = set_audit_status(audit_status, "WARNING")

    return audit_status

def set_audit_status(old_audit_status, new_audit_status):
    """Maintain higher criticality for audit status."""
    audit_level = {"OK": 0, "WARNING": 1, "ERROR": 2}

    old_status = old_audit_status.upper().strip()
    new_status = new_audit_status.upper().strip()

    if audit_level.get(new_status, -1) > audit_level.get(old_status, -1):
        return new_status
    else:
        return old_audit_status
